Unit MainForm;

Interface

Uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, OSVersion;

Const   DIR_DESKTOP  = 'Plocha';
        DIR_PROGRAMS = 'Nabdka Start\Programy';
        DIR_START    = 'Nabdka Start';

Type
  TPolozka = Record
             FileName : String;
             ImageIndex    : Integer;
             end;
  PPolozka = ^TPolozka;
  TDMViewStyle = (dmvsPrograms, dmvsDesktop, dmvsStart);

  TForm1 = Class (TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Konec1: TMenuItem;
    ListView1: TListView;
    Nastaven1: TMenuItem;
    Prohletpodadrese1: TMenuItem;
    N1: TMenuItem;
    Programy1: TMenuItem;
    NabdkaStart1: TMenuItem;
    Pracovnplocha1: TMenuItem;
    Procedure FormCreate(Sender: TObject);
    Procedure Konec1Click(Sender: TObject);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure Programy1Click(Sender: TObject);
    procedure Prohletpodadrese1Click(Sender: TObject);
  Private
   FViewStyle : TDMViewStyle;
   FBasePath  : String;
   ExtraPath  : String;
   FScanDirs  : Boolean;
   Procedure CreateUserColumns;
   Procedure ListViewAddColumn(AName:String);
   Procedure VypisPolozky(APath:String);
   Function  DeleteObject(FileName:String):Boolean;
   Function  CopyObject(FileName,NewFileName:String):Boolean;
  end;

Var
  Form1: TForm1;

Implementation

{$R *.DFM}

Uses ShellAPI;

Procedure TForm1.ListViewAddColumn(AName:String);
begin
With ListView1.Columns.Add Do
     begin
     Caption:=AName;
     DisplayName:=AName;
     AutoSize:=True;
     end;
end;

Procedure TForm1.CreateUserColumns;
Var  DirInfo : TSearchRec;
begin
If Win9x Then
   ListViewAddColumn('..');
If FindFirst(FBasePath+'*.*',FaAnyFile,DirInfo) = 0 Then
   begin
   Repeat
   If (DirInfo.Name = '.') Or
      (DirInfo.Name = '..') Or
      (DirInfo.Attr And FILE_ATTRIBUTE_DIRECTORY = 0) Then
      Continue;
   If (DirectoryExists(FBasePath+DirInfo.Name+'\'+DIR_DESKTOP)) And
      (DirectoryExists(FBasePath+DirInfo.Name+'\'+DIR_START)) Then
      ListViewAddColumn(DirInfo.Name);
   Until FindNext(DirInfo) > 0;
   FindClose(DirInfo);
   end;
end;

Procedure TForm1.FormCreate(Sender: TObject);
Var Zaznam : _SHFILEINFOA;
    Index  : Integer;
begin
FScanDirs:=False;
If WinXP Then
   FBasePath:='C:\Documents and Settings\'
Else If Win9x Then
   FBasePath:='C:\Windows\Profiles\'
Else ExitProcess(0);
ListView1.SmallImages:=TImageLIst.Create(ListView1);
ListView1.SmallImages.ShareImages:=True;
ListView1.SmallImages.Handle:=SHGetFileInfo(PAnsiChar(Application.ExeName),0,Zaznam,SizeOf(Zaznam),SHGFI_ICON Or SHGFI_SMALLICON Or SHGFI_SYSICONINDEX);
CreateUserColumns;
Index:=0;
If Assigned(ListView1.Selected) Then
   Index:=ListView1.Selected.Index;
ListView1.Clear;
VypisPolozky('');
If ListView1.Items.Count > Index Then
   ListView1.Items[Index].Selected:=True;
end;

Procedure TForm1.VypisPolozky(APath:String);
Var DirInfo   : TSearchRec;
    Polozka   : PPolozka;
    UsrName   : String;
    I         : Integer;
    J         : Integer;
    K         : Integer;
    SHFileInfo : _SHFILEINFOA;
    Existuje : Boolean;
begin
Case FViewStyle Of
     dmvsPrograms : ExtraPath:=DIR_PROGRAMS+'\';
     dmvsDesktop  : ExtraPath:=DIR_DESKTOP+'\';
     dmvsStart    : ExtraPath:=DIR_START+'\';
     end;
ListView1.Items.BeginUpdate;
For I:=1 To ListView1.Columns.Count-1 Do
    begin
    UsrName:=ListView1.Columns[I].Caption+'\';
    If FindFirst(FBasePath+UsrName+ExtraPath+APath+'*.*',FaAnyFile,DirInfo) = 0 Then
       begin
       Repeat
       If (DirInfo.Name = '.') Or
          (DirInfo.Name = '..') Then
          Continue;
       DirInfo.Name:=APath+DirInfo.Name;
       Existuje:=False;
       For K:=0 To ListView1.Items.Count-1 Do
           begin
           If ListView1.Items[K].Caption = DirInfo.Name Then
              Existuje:=True;
           end;
       If Existuje Then
          Continue;
       New(Polozka);
       Polozka.FileName:=DirInfo.Name;
       SHGetFileInfo(PAnsiChar(FBasePath+UsrName+ExtraPath+DirInfo.Name),0,SHFileInfo,SizeOf(SHFileInfo),SHGFI_ICON Or SHGFI_SMALLICON Or SHGFI_SYSICONINDEX);
       Polozka.ImageIndex:=SHFileInfo.iIcon;
       With ListView1.Items.Add Do
            begin
            Caption:=Polozka.FileName;
            ImageIndex:=Polozka.ImageIndex;
            Data:=Polozka;
            For J:=1 To ListView1.Columns.Count-1 Do
                begin
                If (FileExists(FBasePath+ListView1.Columns[J].Caption+'\'+ExtraPath+DirInfo.Name)) Or
                   (DirectoryExists(FBasePath+ListView1.Columns[J].Caption+'\'+ExtraPath+DirInfo.Name)) Then
                   SubItems.Add('Ano')
                Else SubItems.Add('Ne');
                end;
            end;
       If (FScanDirs) And
          (DirInfo.Attr And FILE_ATTRIBUTE_DIRECTORY > 0) Then
          VypisPolozky(DirInfo.Name+'\');
       Until FindNext(DirInfo) > 0;
       FindClose(DirInfo);
       end;
    end;
ListView1.Items.EndUpdate;
end;

Procedure TForm1.Konec1Click(Sender: TObject);
begin
Close;
end;

Procedure TForm1.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
Var UsrName : String;
    Index   : Integer;
    I       : Integer;
    Index2  : Integer;
begin
If Assigned(ListView1.Selected) And
   (Column.Index > 0) Then
   begin
   UsrName:=Column.Caption;
   Index:=Column.Index;
   If ListView1.Selected.SubItems[Index-1] = 'Ano' Then
      begin
      If DeleteObject(FBasePath+UsrName+'\'+ExtraPath+PPolozka(ListView1.Selected.Data).FileName) Then
         begin
         Index2:=0;
         If Assigned(ListView1.Selected) Then
            Index2:=ListView1.Selected.Index;
         ListView1.Clear;
         VypisPolozky('');
         If ListView1.Items.Count > Index2 Then
            ListView1.Items[Index2].Selected:=True;
         end;
      end
   Else begin
        For I:=0 To ListView1.Columns.Count-1 Do
            begin
            If (FileExists(FBasePath+ListView1.Columns[I].Caption+'\'+ExtraPath+PPolozka(ListView1.Selected.Data).FileName)) Or
               (DirectoryExists(FBasePath+ListView1.Columns[I].Caption+'\'+ExtraPath+PPolozka(ListView1.Selected.Data).FileName)) Then
               begin
               If CopyObject(FBasePath+ListView1.Columns[I].Caption+'\'+ExtraPath+PPolozka(ListView1.Selected.Data).FileName,FBasePath+Column.Caption+'\'+ExtraPath+PPolozka(ListView1.Selected.Data).FileName) Then
                  begin
                  Index2:=0;
                  If Assigned(ListView1.Selected) Then
                     Index2:=ListView1.Selected.Index;
                  ListView1.Clear;
                  VypisPolozky('');
                  If ListView1.Items.Count > Index2 Then
                     ListView1.Items[Index2].Selected:=True;
                  Exit;
                  end;
               end;
            end;
        MessageDlg('Soubor nen k dispozici!',MtError,[MbOk],0);
        end;
   end;
end;

Function  TForm1.DeleteObject(FileName:String):Boolean;
Var Struct : _SHFILEOPSTRUCTA;
begin
Struct.Wnd:=0;
Struct.wFunc:=FO_DELETE;
Struct.pFrom:=PAnsiChar(FileName+#0);
Struct.pTo:='';
Struct.fFlags:=FOF_SIMPLEPROGRESS Or FOF_SILENT Or FOF_NOCONFIRMATION;
Struct.lpszProgressTitle:='Mazn';
Result:= SHFileOperation(Struct) = 0;
end;

Function  TForm1.CopyObject(FileName,NewFileName:String):Boolean;
Var Struct : _SHFILEOPSTRUCTA;
begin
Struct.Wnd:=0;
Struct.wFunc:=FO_COPY;
Struct.pFrom:=PAnsiChar(FileName+#0);
Struct.pTo:=PAnsiChar(NewFileName+#0);
Struct.fFlags:=FOF_SIMPLEPROGRESS Or FOF_SILENT Or FOF_NOCONFIRMATION;
Struct.lpszProgressTitle:='Koprovn';
Result:= SHFileOperation(Struct) = 0;
end;

Procedure TForm1.Programy1Click(Sender: TObject);
Var M : TMenuItem;
begin
M:=Sender As TMenuItem;
M.Checked:= Not M.Checked;
If M.Checked Then
   begin
   Case M.MenuIndex Of
        2 : FViewStyle:=dmvsPrograms;
        3 : FViewStyle:=dmvsStart;
        4 : FViewStyle:=dmvsDesktop;
        end;
   ListView1.Clear;
   VypisPolozky('');
   end;
end;

Procedure TForm1.Prohletpodadrese1Click(Sender: TObject);
Var M : TmenuItem;
    Index : Integer;
begin
M:=Sender As TMenuItem;
M.Checked:=Not M.Checked;
FScanDirs:=M.Checked;
Index:=0;
If Assigned(ListView1.Selected) Then
   Index:=ListView1.Selected.Index;
ListView1.Clear;
VypisPolozky('');
If ListView1.Items.Count > Index Then
   ListView1.Items[Index].Selected:=True;
end;

End.
